#include "mpi.h"
#include <stdlib.h>
#include <stdio.h>

#define RED 0
#define BLACK 1
#define MX 32

int coords[2];
double func(double,double);

main(int argc, char *argv[]){

	/*MPI_Comm MPI_COMM_WORLD;*/
	MPI_Datatype c_column;
	MPI_Status status;
	MPI_Comm mesh2;
	double input[MX+1][MX+1], work[MX+1][MX+1];

	int me,n ;
	int nprocs ;
	int i,j,r;

	double omega,condi;
int continue_loop;

	double test, test_max, test_l[4];

	int col_tag=5, row_tag=6,up,down,left,right;

	int dim[2], period[2],reorder;

	MPI_Init(&argc,&argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &me);
	/*MPI_Comm_size(MPI_COMM_WORLD, &nprocs);*/
	
	printf("me number %d\n",me);
	dim[0]=2;dim[1]=2;
	period[0]=0;period[1]=0;
	reorder=0;

	MPI_Cart_create(MPI_COMM_WORLD,2,dim,period,reorder,&mesh2);
	MPI_Cart_coords(mesh2,me,2,coords);

	if (me==0)
		get_input(input);

	/* broadcast here */
	MPI_Bcast(input, (MX+1)*(MX+1),MPI_DOUBLE,0,MPI_COMM_WORLD);

	MPI_Type_vector(MX,1,MX+1,MPI_DOUBLE,&c_column);
	MPI_Type_commit(&c_column);

	MPI_Cart_shift(mesh2,0,1,&up,&down);
	MPI_Cart_shift(mesh2,1,1,&left,&right);

	condi = 0.01;
	omega=1.3;

	continue_loop = 1;

	for (i=1;i<MX;i++)
		for (j=1;j<MX;j++)
			work[i][j]=input[i][j];

	for(n=0;(continue_loop==1);n++){
		int check=0;

		MPI_Sendrecv(&input[0][1],1,c_column,left,col_tag,&input[0][MX],
			1,c_column,right,col_tag,mesh2,&status);
		MPI_Sendrecv(&input[0][MX-1],1,c_column,right,col_tag,&input[0][0],
			1,c_column,left,col_tag,mesh2,&status);
		MPI_Sendrecv(&input[1][0],MX,MPI_DOUBLE,up,row_tag,mesh2,
			&status);
		MPI_Sendrecv(&input[MX-1][0],MX,MPI_DOUBLE,down,row_tag,
			&input[0][0],MX,MPI_DOUBLE,up,row_tag,mesh2,&status);

		for(i = 1 ; i < MX;i=i+2)
			for(j=1;j<MX;j=j+2)
				input[i][j] = omega*( (input[i+1][j]+input[i-1][j]+input[i][j+1]
					+input[i][j-1])*0.25) - (omega-1)*
					input[i][j];

		for(i=2;i<MX;i=i+2)
			for(j=2;j<MX;j=j+2)
				input[i][j]=omega*((input[i+1][j]+input[i-1][j]+input[i][j+1]
					+input[i][j-1])*0.25)-(omega-1)*input[i][j];
		for(i = 1 ; i < MX;i=i+2)
			for(j=2;j<MX;j=j+2)
				input[i][j]=omega*((input[i+1][j]+input[i-1][j]+input[i][j+1]
					+input[i][j-1])*0.25)-(omega-1)*input[i][j];
		for(i=2;i<MX;i=i+2)
			for(j=1;j<MX;j=j+2)
				input[i][j]=omega*((input[i+1][j]+input[i-1][j]+input[i][j+1]
					+input[i][j-1])*0.25)-(omega-1)*input[i][j];
		test_max = 0;
		for(i=1;i<MX;i++)
			for(j=1;j<MX;j++){
				if(work[i][j]>=input[i][j])
					test=work[i][j]-input[i][j];
				else
					test=input[i][j]-work[i][j];
				if(test > test_max)
					test_max=test;
			}
		test_l[me] = test_max;

		for(r=0;(r<4)&&(check!=1);r++)
			if(test_l[r] > condi)
				check = 1;
			if(check==0)
				continue_loop=0;

		for(i=1;i<MX;i++)
			for(j=1;j<MX;j++)
				work[i][j] = input[i][j];
		};

		if (me==0)
    			printf("number of iterations %d\n",n);

		MPI_Finalize();
	
}

get_input(double imat[MX+1][MX+1]){

	int i,j;

	for (i = 0 ; i < MX+1 ; i ++)
		for (j = 0 ; j < MX+1;j ++)
			imat[i][j] = 0;

	for (i = 0 ; i < MX+1; i ++)
		imat[MX*coords[0]][i] = func((MX*coords[0]),i);
	for ( i = 0 ; i < MX+1 ; i ++)
		imat[i][MX*coords[1]] = func(i,(MX*coords[1]));

}
      
double func(double x, double y){
	return(-4.7+0,2*x-0.3*y+0.09*(x*x-y*y)+log10(sqrt((x+2)*(x+2)+(y+0.2)*(y+0.2))));
}
